#!/bin/bash

KYARCH=$(arch)

###chroot
if [ "${KYARCH}" == "aarch64" ];then
  if [ -f /target/usr/sbin/grub-install ];then
    echo "${KYARCH}: chroot /target grub-install... "
    chroot /target grub-install --kylin-no-efi-register
  fi
  if [ -f /target/usr/sbin/grub-mkconfig ];then
    echo "${KYARCH}: chroot /target grub-mkconfig... "
    chroot /target grub-mkconfig -o /boot/grub/grub.cfg
  fi
  if [ -f /target/usr/bin/grub-mkimage ] && [ ! -f /target/boot/efi/EFI/boot/bootaa64.efi ] && [ ! -f /target/boot/efi/EFI/BOOT/BOOTAA64.EFI ];then
    echo "${KYARCH}: chroot /target grub-mkimage... "
    mkdir -p /target/boot/efi/EFI/boot
    chroot /target grub-mkimage -o '/boot/efi/EFI/boot/bootaa64.efi' -O 'arm64-efi' -d '/usr/lib/grub/arm64-efi'  fat ext2 part_msdos search_fs_uuid search_label search_fs_file search normal linux font all_video reboot configfile test
    cp /target/boot/efi/EFI/boot/bootaa64.efi /target/boot/efi/EFI/boot/grubaa64.efi
  fi
fi


###nochroot
if [ "${KYARCH}" == "aarch64" ];then
  if [ -d /target/boot/efi ];then
    if [ -d /cdrom/ESP ];then
      rsync -a /cdrom/ESP/ /target/boot/efi/
    fi

    mkdir -p /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/efi/boot/grub
    cp /target/boot/grub/grub.cfg /target/boot/grub/grub.cfg-old
    GRUB_DEVICE_BOOT=`grub-probe --target=device /target/boot`
    GRUB_ROOT=`grub-probe --device $GRUB_DEVICE_BOOT --target=compatibility_hint`
    GRUB_EFI_CFG="/target/boot/efi/boot/grub/grub.cfg"
    sed -i "s/set root=(\${root})/set root='$GRUB_ROOT'/g" $GRUB_EFI_CFG
    sed -i 's#/uImage #/Image #g' $GRUB_EFI_CFG
    sed -i 's/console=ttyS.,115200 earlyprintk=uart8250-32bit,0x28001000//g' $GRUB_EFI_CFG
    sed -i '/devicetree/d' $GRUB_EFI_CFG
    # cp /target/boot/efi/boot/grub/grub.cfg /target/boot/grub/grub.cfg
  fi

  if [ -f /target/boot/efi/EFI/kylin/grubaa64.efi ] && [ ! -f /target/boot/efi/EFI/boot/bootaa64.efi ] && [ ! -f /target/boot/efi/EFI/BOOT/BOOTAA64.EFI ];then
    mkdir -p /target/boot/efi/EFI/boot
    cp /target/boot/efi/EFI/kylin/grubaa64.efi /target/boot/efi/EFI/boot/bootaa64.efi
  fi
fi

if [ "${KYARCH}" == "x86_64" ];then
  if [ -f /target/boot/efi/EFI/kylin/grubx64.efi ] && [ ! -f /target/boot/efi/EFI/boot/bootx64.efi ] && [ ! -f /target/boot/efi/EFI/BOOT/BOOTX64.EFI ];then
    mkdir -p /target/boot/efi/EFI/boot
    cp /target/boot/efi/EFI/kylin/grubx64.efi /target/boot/efi/EFI/boot/bootx64.efi
  fi
fi

### OEM
echo "OEM config: "
if [ -f /target/usr/sbin/oem-config-prepare ];then
    chroot /target /usr/sbin/oem-config-prepare
fi

